# class Prism::ReturnNode

Represents the use of the ‘return` keyword.

    return 1
    ^^^^^^^^

### Attributes

arguments [R]

attr_reader arguments: `ArgumentsNode`?

### Public Class Methods

new (source, node_id, location, flags, keyword_loc, arguments)
Source

    # File lib/prism/node.rb, line 16041
    def initialize(source, node_id, location, flags, keyword_loc, arguments)
      @source = source
      @node_id = node_id
      @location = location
      @flags = flags
      @keyword_loc = keyword_loc
      @arguments = arguments
    end

Initialize a new `ReturnNode` node.

type ()
Source

    # File lib/prism/node.rb, line 16117
    def self.type
      :return_node
    end

Return a symbol representation of this node type. See ‘Node::type`.

### Public Instance Methods

=== (other)
Source

    # File lib/prism/node.rb, line 16123
    def ===(other)
      other.is_a?(ReturnNode) &&
        (keyword_loc.nil? == other.keyword_loc.nil?) &&
        (arguments === other.arguments)
    end

Implements case-equality for the node. This is effectively == but without comparing the value of locations. Locations are checked only for presence.

accept (visitor)
Source

    # File lib/prism/node.rb, line 16051
    def accept(visitor)
      visitor.visit_return_node(self)
    end

def accept: (`Visitor` visitor) -> void

child_nodes ()
Source

    # File lib/prism/node.rb, line 16056
    def child_nodes
      [arguments]
    end

def `child_nodes`: () -> Array[nil | Node]

Also aliased as: deconstruct
comment_targets ()
Source

    # File lib/prism/node.rb, line 16068
    def comment_targets
      [keyword_loc, *arguments] #: Array[Prism::node | Location]
    end

def `comment_targets`: () -> Array[Node | Location]

compact_child_nodes ()
Source

    # File lib/prism/node.rb, line 16061
    def compact_child_nodes
      compact = [] #: Array[Prism::node]
      compact << arguments if arguments
      compact
    end

def `compact_child_nodes`: () -> Array

copy (node_id: self.node_id, location: self.location, flags: self.flags, keyword_loc: self.keyword_loc, arguments: self.arguments)
Source

    # File lib/prism/node.rb, line 16073
    def copy(node_id: self.node_id, location: self.location, flags: self.flags, keyword_loc: self.keyword_loc, arguments: self.arguments)
      ReturnNode.new(source, node_id, location, flags, keyword_loc, arguments)
    end

def copy: (?node_id: `Integer`, ?location: `Location`, ?flags: `Integer`, ?keyword_loc: `Location`, ?arguments: `ArgumentsNode`?) -> `ReturnNode`

deconstruct ()

def deconstruct: () -> Array[nil | Node]

Alias for: child_nodes
deconstruct_keys (keys)
Source

    # File lib/prism/node.rb, line 16081
    def deconstruct_keys(keys)
      { node_id: node_id, location: location, keyword_loc: keyword_loc, arguments: arguments }
    end

def `deconstruct_keys`: (Array keys) -> { node_id: `Integer`, location: `Location`, `keyword_loc`: `Location`, arguments: `ArgumentsNode`? }

inspect ()
Source

    # File lib/prism/node.rb, line 16107
    def inspect
      InspectVisitor.compose(self)
    end

def inspect -> `String`

keyword ()
Source

    # File lib/prism/node.rb, line 16102
    def keyword
      keyword_loc.slice
    end

def keyword: () -> `String`

keyword_loc ()
Source

    # File lib/prism/node.rb, line 16086
    def keyword_loc
      location = @keyword_loc
      return location if location.is_a?(Location)
      @keyword_loc = Location.new(source, location >> 32, location & 0xFFFFFFFF)
    end

attr_reader `keyword_loc`: `Location`

save_keyword_loc (repository)
Source

    # File lib/prism/node.rb, line 16094
    def save_keyword_loc(repository)
      repository.enter(node_id, :keyword_loc)
    end

Save the `keyword_loc` location using the given saved source so that it can be retrieved later.

type ()
Source

    # File lib/prism/node.rb, line 16112
    def type
      :return_node
    end

Return a symbol representation of this node type. See ‘Node#type`.